// Copyright (C) 1996 DIMACS Center, Rutgers, The State University of New Jersey
// Author(s): Jonathan Berry

// This software is copyrighted by the DIMACS Center at Rutgers, The State
// University of New Jersey.  IT IS PROVIDED AS IS, AND THE AUTHORS, DIMACS, AND
// RUTGERS, THE STATE UNIVERSITY OF NEW JERSEY  DISCLAIM
// ALL LIABILITY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL
// DAMAGES ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY
// DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.

// THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,
// INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE
// IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE
// NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
// MODIFICATIONS.

// The authors hereby grant permission to use, copy, modify, distribute,
// and license this software and its documentation for any purpose, provided
// that existing copyright notices are retained in all copies and that this
// notice is included verbatim in any distributions. No written agreement,
// license, or royalty fee is required for any of the authorized uses.
// Modifications to this software may be copyrighted by their authors
// and need not follow the licensing terms described here, provided that
// the new terms are clearly indicated on the first page of each file where
// they apply.

// Last File Update: 31-Jul-1996
// 

#ifndef DBinGraph_h
#define DBinGraph_h

#include <LINK/graph/BinGraph.h>

class Edge;


class MDBinGraph : public MBinGraph {
protected:

    Edge*		addEdge(Edge *e);

public:

    MDBinGraph() {}
    MDBinGraph(const MDBinGraph &G, Flag clone=CLONE, Flag reverse=0,
			Flag new_simple=MULTI) 
				: MBinGraph(G, clone, reverse,
					DIRECTED, new_simple) {}
    MDBinGraph(const Graph &G, Flag clone=CLONE, Flag reverse=0,
			Flag new_simple=MULTI) 
				: MBinGraph(G, clone, reverse,
					DIRECTED, new_simple) {}

			// managing subgraphs
    Graph*              newGraph() { return (Graph*) new MDBinGraph; }
    Graph*              copyGraph(Flag clone = CLONE, Flag reverse=0) 
			{ return (Graph*) new MDBinGraph(*this, clone,reverse);}

			// override for directed binary graph
    Edge*		addEdge(Collection<Vertex*>&passed_vertices,String n=0);
    Edge*		addEdge(Sequence<Vertex*> vs, String n=0);
    Edge*		addEdge(Vertex* v1, Vertex* v2, String n=0);

    DataType		type() const	{ return M_DIRBINARYGRAPH; }
};

class DBinGraph : public MDBinGraph {
public:
    DBinGraph() {}
    DBinGraph(const DBinGraph &G, Flag clone=CLONE, Flag reverse=0) 
				: MDBinGraph(G, clone, reverse, SIMPLE) {}
    DBinGraph(const Graph &G, Flag clone=CLONE, Flag reverse=0) 
				: MDBinGraph(G, clone, reverse, SIMPLE) {}
    Graph*              newGraph() { return (Graph*) new DBinGraph; }
    Graph*              copyGraph(Flag clone = CLONE, Flag reverse = 0) 
			{ return (Graph*) new DBinGraph(*this, clone,reverse); }
    Edge*	addEdge(MSet<Vertex*> vs, String n=0)
		   {return isEdge(vs,DIRECTED) ? (Edge*)0 
					       : MDBinGraph::addEdge(vs, n); }
    Edge*	addEdge(Sequence<Vertex*> vs, String n=0)
		   {return isEdge(vs,DIRECTED) ? (Edge*)0 
					       : MDBinGraph::addEdge(vs, n); }
    DataType	type() const	{ return DIRBINARYGRAPH; }
};

#endif
